* **********************************************
* *             TSMC RF SPICE MODEL            *
* **********************************************
* This model has been modified for RF purpose. MOS & DIO was modified.
*  
*    PROCESS :  0.18um Mixed-Signal SALICIDE (1P6M+, 1.8V/3.3V)
*     MODEL  :  BSIM3 ( V3.2 )
*    DOC. NO.:  T-018-MM-SP-001 
*    VERSION :  1.1 
*    DATE    :  Oct.25, 2002
*    HSPICE VERSION : H98.4
*
*******************************************************************************
*                                                                             *
*       IN THIS MODEL LIB CONTAINS :                                          *
*                                                                             *
*       1.LIB TT_RFMOS                                                        *
*       ( Typical model for 1.8V/3.3V nominal Vt N/P devices and MIM          *
*         capacitor, spiral inductor, MOS varactor, resistor and junction     *
*         capacitor sub-circuit )                                             *
*                                                                             *
*       2.LIB FF_RFMOS                                                        *
*       ( Fast-Fast corner model for 1.8V/3.3V nominal Vt N/P devices and MIM *
*         capacitor, spiral inductor, MOS varactor, resistor and junction     *
*         capacitor sub-circuit )                                             *
*                                                                             *
*       3.LIB SS_RFMOS                                                        *
*       ( Slow-Slow corner model for 1.8V/3.3V nominal Vt N/P devices and MIM *
*         capacitor, spiral inductor, MOS varactor, resistor and junction     *
*         capacitor sub-circuit )                                             *
*                                                                             *
******************************************************************************
*
* 1)To use these models directly by programming in this style: 
*
*     .lib 'lib_path/lib_name' xx_RFMOS       (xx represents TT, FF or SS)
*    
*
*  EX1: .lib '/home/user/tsmc/LOGIC/rf018.l' TT_RFMOS
*  
*             for all typical MOS Devices
*      
*  EX2: .lib '/home/user/tsmc/LOGIC/rf018.l' FF_RFMOS
*  
*             for all Fast-Fast corner MOS Devices
*
*  EX3: .lib '/home/user/tsmc/LOGIC/rf018.l' SS_RFMOS
*  
*             for all Slow-Slow corner MOS Devices
*      
* 2)Please note that AS/AD and PS/PD must be set to zero to result in correct
*   output impedance.
*
.LIB TT_RFMOS
.param nmos_rgfac   = 1.0    pmos_rgfac   = 1.0
+      nmos_rsubfac = 1.0    pmos_rsubfac = 1.0
+      nmos_uefffac = 1.0    pmos_uefffac = 1.0
+      nmos_vthfac  = 1.0    pmos_vthfac  = 1.0
+      nmos_toxfac  = 1.0    pmos_toxfac  = 1.0
+      nmos_dlfac   = 1.0    pmos_dlfac   = 1.0
+      nmos_dwfac   = 0.0    pmos_dwfac   = 0.0
+      nmos_rdswfac = 1.0    pmos_rdswfac = 1.0
+      nmos_k1fac   = 1.0    pmos_k1fac   = 1.0
+      nmos_cgdfac  = 1.0    pmos_cgdfac  = 1.0
+      ndio_cjfac   = 1.0    pdio_cjfac   = 1.0
+      rctm_fac     = 1.0
+      L_fac        = 1.0
+      cmim_fac     = 1.0
+      cm5_fac      = 1.0
+      rsub_fac     = 1.0
+      csub_fac     = 1.0
+      rm6_fac      = 1.0
+      cs_fac       = 1.0
+      cm6_fac      = 1.0
+      cmv_fac      = 1.0
+      rm1_fac      = 1.0
+      cj_fac       = 1.0
+      cpoly_fac    = 1.0
+      rnpolys_fac  = 1.0
+      rnpolyl_fac  = 1.0
+      rppolys_fac  = 1.0
+      rppolyl_fac  = 1.0
+      rnpolywos_fac= 1.0
+      rnpolywol_fac= 1.0
+      rppolywos_fac= 1.0
+      rppolywol_fac= 1.0
+      rnodwo_fac   = 1.0
+      rpodwo_fac   = 1.0
+      rppolyhri_fac= 1.0     
.lib 'rf018.l' RF_MACRO 
.ENDL TT_RFMOS
*
.LIB FF_RFMOS
.param nmos_rgfac   = 0.55	  pmos_rgfac   = 0.742	
+      nmos_rsubfac = 0.85	  pmos_rsubfac = 0.85	
+      nmos_uefffac = 1.02554	  pmos_uefffac = 1.0149	
+      nmos_vthfac  = 0.966423	  pmos_vthfac  = 0.992553	
+      nmos_toxfac  = 0.985702	  pmos_toxfac  = 0.994121	
+      nmos_dlfac   = 2.739121    pmos_dlfac   = 2.104354	
+      nmos_dwfac   = 0.039328    pmos_dwfac   = -0.00485757	
+      nmos_rdswfac = 0.83611	  pmos_rdswfac = 1.11353	
+      nmos_k1fac   = 0.986757	  pmos_k1fac   = 1.01792	
+      nmos_cgdfac  = 0.91	  pmos_cgdfac  = 0.901	
+      ndio_cjfac   = 0.803195	  pdio_cjfac   = 0.912706	
+      rctm_fac     = 0.8273
+      L_fac        = 0.9762
+      cmim_fac     = 0.9091
+      cm5_fac      = 0.9538
+      rsub_fac     = 1.2000
+      csub_fac     = 0.8944
+      rm6_fac      = 0.7929
+      cs_fac       = 0.7764
+      cm6_fac      = 0.9551
+      cmv_fac      = 0.9556
+      rm1_fac      = 0.8034
+      cj_fac       = 0.9500
+      cpoly_fac    = 0.9427
+      rnpolys_fac  = 0.5088
+      rnpolyl_fac  = 0.8198
+      rppolys_fac  = 0.6517
+      rppolyl_fac  = 0.7863
+      rnpolywos_fac= 0.8493
+      rnpolywol_fac= 0.8493
+      rppolywos_fac= 0.8607
+      rppolywol_fac= 0.8607
+      rnodwo_fac   = 0.9345
+      rpodwo_fac   = 0.9048
+      rppolyhri_fac= 0.8000 
.lib 'rf018.l' RF_MACRO
.ENDL FF_RFMOS
*
.LIB SS_RFMOS
.param nmos_rgfac   = 1.45	  pmos_rgfac   = 1.258	
+      nmos_rsubfac = 1.15	  pmos_rsubfac = 1.15	
+      nmos_uefffac = 0.974461	  pmos_uefffac = 0.985095	
+      nmos_vthfac  = 1.03358	  pmos_vthfac  = 1.00745	
+      nmos_toxfac  = 1.0143	  pmos_toxfac  = 1.00588	
+      nmos_dlfac   = -0.73912	  pmos_dlfac   = -0.10435	
+      nmos_dwfac   = -0.0393285  pmos_dwfac   = 0.00485757	
+      nmos_rdswfac = 1.16389	  pmos_rdswfac = 0.886469	
+      nmos_k1fac   = 1.01324	  pmos_k1fac   = 0.982085	
+      nmos_cgdfac  = 1.09	  pmos_cgdfac  = 1.099	
+      ndio_cjfac   = 1.19681	  pdio_cjfac   = 1.08729	
+      rctm_fac     = 1.1727
+      L_fac        = 1.0235
+      cmim_fac     = 1.1111
+      cm5_fac      = 1.0520
+      rsub_fac     = 0.8000
+      csub_fac     = 1.0954
+      rm6_fac      = 1.2071
+      cs_fac       = 1.2236
+      cm6_fac      = 1.0509
+      cmv_fac      = 1.0444
+      rm1_fac      = 1.1966
+      cj_fac       = 1.0500
+      cpoly_fac    = 1.0747
+      rnpolys_fac  = 1.4912
+      rnpolyl_fac  = 1.1802
+      rppolys_fac  = 1.3483
+      rppolyl_fac  = 1.2137
+      rnpolywos_fac= 1.1507
+      rnpolywol_fac= 1.1507
+      rppolywos_fac= 1.1393
+      rppolywol_fac= 1.1393
+      rnodwo_fac   = 1.0655
+      rpodwo_fac   = 1.0952
+      rppolyhri_fac= 1.2000
.lib 'rf018.l' RF_MACRO 
.ENDL SS_RFMOS
***************************************************************************
*

.LIB RF_MACRO
**************************************************************************************************
*
*1) MOS MODEL :
*
*  A) HSPICE LEVEL 49:
*  
*     ## library files:
*     
*     All models are included in file 'rf018.l' for H98.4 
*     
*      
*           a. Normal 1.8V N/PMOS model
*           
*              .lib MOS_RF : Typical model
*              
*              Model name       NF               L (um)             Wf (um)
*                            low   high        low    high     
*            -----------------------------------------------------------------              
*              nmos_rf        4     128        0.18   0.5           2.5
*            -----------------------------------------------------------------
*              pmos_rf       16     128        0.18   0.5           2.5 
*            -----------------------------------------------------------------                  
*            **NF: Finger number
*      
*           b. Normal 3.3V N/PMOS model
*           
*              .lib MOS_RF33 : Typical model
*              
*              Model name       NF               L (um)             Wf (um)
*                            low   high        low    high     
*            -----------------------------------------------------------------              
*              nmos_rf33     16     64         0.35   0.5           2.5
*            -----------------------------------------------------------------
*              pmos_rf33     16     64         0.3    0.5           2.5 
*            -----------------------------------------------------------------                  
*            **NF: Finger number
*                          
*                                          
*          The N/P MOS are modeled with sub-circuit nmos_rf/pmos_rf which internally 
*          call the device libraries - .LIB MOS_RF and .LIB DIO_RF saved in the file rf018.l
*
*
**************************************************************************************************

.SUBCKT nmos_rf D G S B lr=18.E-08 nr=12.8E+01 
**********************
RG  G GI   R='(0.346*nr+72.849*lr*1e+6+86.075)*nmos_rgfac' M=nr
RB  B BI   R='((62.4/nr+2.0808)/lr*1e-6+1532.6/nr-0.5858)*nmos_rsubfac'
RS  S SI   R='((0.6584*lr*1e+6+0.9106)*nr+203.68*lr*1e+6-60.219+abs((0.6584*lr*1e+6+0.9106)*nr+203.68*lr*1e+6-60.219))/2' M=nr 
RD  D DI   R='(0.0248/lr*1e-6/lr*1e-6-0.0497/lr*1e-6+0.0602)*(nr-1)' M=nr
****Rds*****************
Rds SI  XX R='(2e+6*lr*1e+6-237663)/nr+2753.8*lr*1e+6+2615.3'
Cds DI  XX C='(0.7609*nr+11.791)*1e-15'
***** Diodes  ****************
DSS  SB  SI  ndio_rf_f AREA = '(nr/2+1)*2.5e-6*6.4e-7'  PJ='1.28e-6*(nr/2+1)+2*2.5e-6' 
DDD  DB  DI  ndio_rf_f AREA = 'nr/2*2.5e-6*6.4e-7'      PJ='1.28e-6*nr/2'   
DSG  SB  SI  ndio_rf_g  AREA = 1E-15 PJ = '2.5e-6*nr'  
DDG  DB  DI  ndio_rf_g  AREA = 1E-15 PJ = '2.5e-6*nr'  
*****************************************************************************
Rdb  DB  BI  R='21.2/nr+0.0892/lr*1e-6/lr*1e-6-0.173/lr*1e-6+0.1'
Rsb  SB  BI  R='21.2/nr+0.0892/lr*1e-6/lr*1e-6-0.173/lr*1e-6+0.1'
******* MOSFET *******
M0  DI GI SI BI nch_rf L = lr W = 2.5e-6 M = nr AD = 0 AS = 0 PD = 0 PS = 0  
.ENDS nmos_rf

.SUBCKT pmos_rf D G S B lr=18.E-08 nr=12.8E+01   
**********************
RG GI G  R='((1.4194*lr*1e+6-0.0751)*nr+206.96*lr*1e+6+46.76)*pmos_rgfac' M=nr
RB BI B  R='((54.773/nr-0.062)/(lr*1e+6)+502.77/nr+1.0575)*pmos_rsubfac'
**********  Rs and Rd  *****************
Rs  S SI R='0.00405*nr*(lr*1e6+0.8)'
Rd  D DI R='0.00547*nr*(lr*1e6+0.8)'
**Rds*****************
Rds SI  XX R='(67305*lr*1e+6+76660)/nr+2135.7*lr*1e+6+477.87'
Cds DI  XX C='(0.7478*nr+27.13)*1e-15'
***** Diodes  ****************
DSS SI SB  pdio_rf_f AREA = '(nr/2+1)*2.5e-6*6.4e-7'  PJ='(nr/2+1)*1.28e-6+2*2.5e-6'  
DDD DI DB pdio_rf_f AREA = 'nr/2*2.5e-6*6.4e-7'  PJ='nr/2*1.28e-6'  
DSG SI SB pdio_rf_g AREA = 1E-15 PJ = '2.5e-6*nr'  
DDG DI DB pdio_rf_g AREA = 1E-15 PJ = '2.5e-6*nr'  
Rdb DB BI R='6.3111/lr*1e-6+2.4316-(0.0399/lr*1e-6+0.0097)*nr'
Rsb SB BI R='6.3111/lr*1e-6+2.4316-(0.0399/lr*1e-6+0.0097)*nr'
******* MOSFET *******
M0  DI GI SI BI  pch_rf L = lr W = 2.5e-6 M = nr AD = 0 AS = 0 PD = 0 PS = 0  
.ENDS pmos_rf

.lib 'rf018.l' MOS_RF
.lib 'rf018.l' DIO_RF

.SUBCKT nmos_rf33 D G S B lr=35.E-08 nr=12.8E+01   
**********************
RG  G GI  R='((0.8385/lr*1e-6-1.9493)*nr+16.667*lr*1e+6+62.167)*nmos_rgfac' M=nr
RB  B BI  R='((62.4/nr+2.0808)/lr*1e-6+1532.6/nr-0.5858)*nmos_rsubfac'
****Rds*****************
Rds S  XX R='(36267*lr*1e+6-899.33)/nr+4100*lr*1e+6+1910'
Cds D  XX C='(0.7321*nr+9)*1e-15'
***** Diodes  ****************
DSS  SB  S   ndio_rf33_f AREA = '(nr/2+1)*2.5e-6*6.4e-7'  PJ='1.28e-6*(nr/2+1)+2*2.5e-6'  
DDD  DB  D   ndio_rf33_f AREA = 'nr/2*2.5e-6*6.4e-7'  PJ='1.28e-6*nr'  
DSG  SB  S   ndio_rf33_g AREA = 1E-15 PJ = '2.5e-6*nr'  
DDG  DB  D   ndio_rf33_g AREA = 1E-15 PJ = '2.5e-6*nr'  
Rdb DB BI R='14.171/nr+0.3'
Rsb SB BI R='14.171/nr+0.3'
******* MOSFET *******
M0  D GI S BI nch_rf33 L = lr W = 2.5e-6 M = nr AD = 0 AS = 0 PD = 0 PS = 0 
.ENDS nmos_rf33


.SUBCKT pmos_rf33 D G S B lr=35.E-08 nr=12.8E+01   
********************** 
RG GI G  R='(400*lr*1e+6+25)*pmos_rgfac' M=nr
RB BI B  R='((54.773/nr-0.062)/(lr*1e+6)+502.77/nr+1.0575)*pmos_rsubfac'
**Rds*****************
Rds S  XX R='(26515*lr*1e+6+18377)/nr+2600*lr*1e+6-445'
Cds D  XX C='(0.775*nr+11.9)*1e-15'
***** Diodes  ****************
DSS S SB pdio_rf33_f AREA = '(nr/2+1)*2.5e-6*6.4e-7'  PJ='1.28e-6*(nr/2+1)+2*2.5e-6'  
DDD D DB pdio_rf33_f AREA = 'nr/2*2.5e-6*6.4e-7'  PJ='1.28e-6*nr/2'  
DSG S SB pdio_rf33_g AREA = 1E-15 PJ = '2.5e-6*nr'  
DDG D DB pdio_rf33_g AREA = 1E-15 PJ = '2.5e-6*nr'  
Rdb DB BI R='41.43/nr+4' 
Rsb SB BI R='41.43/nr+4'
******* MOSFET *******
M0  D GI S BI pch_rf33 L = lr W = 2.5e-6 M = nr AD = 0 AS = 0 PD = 0 PS = 0  
.ENDS pmos_rf33

.lib 'rf018.l' MOS_RF33
.lib 'rf018.l' DIO_RF33

**************************************************************************************************
* 2) MIM CAPACITOR MODEL :
*
*   HSPICE LEVEL 49:
*  
*     ## library files:
*     
*     The MIM square capacitors are modeled with sub-circuit 'mimcap' for H98.4     
*
*      .subckt mimcap : Typical model
*      
*      
*            Model name        lt               unit
*                          low    high 
*            ----------------------------------------------
*            mimcap        10      30            um
*            ----------------------------------------------
*            **lt: side dimension
*
**************************************************************************************************

.subckt mimcap Top Bottom lt=10u
.param lb='lt+6u'
rs Top n1 '(44.23/(lt*1.0e6)-1.13)*rctm_fac'
ls n1 n2 '(119.3/(lt*1.0e6)+123.5)*1e-12*L_fac'
cmim n2 Bottom '(1.025*(lt*1.0e6)*(lt*1.0e6)+0.97*(lt*1.0e6))*1e-15*cmim_fac'
cox Bottom n3 '(0.0065*(lb*1.0e6)*(lb*1.0e6))*1e-15*cm5_fac'
rsub n3 0 '(7.0e6)/((lb*1.0e6)*(lb*1.0e6))*rsub_fac'
csub n3 0  '1.16e-15*csub_fac'
.ends mimcap

**************************************************************************************************
* 3) SPIRAL INDUCTOR MODEL :
*
*   HSPICE LEVEL 49:
*  
*     ## library files:
*     
*     The Inductors are modeled with sub-circuit 'spiral_turn' and 'spiral_rad' for
*     H98.4
*
*      .subckt spiral_rad  : Typical model for Inductance varies with radius
*      .subckt spiral_turn : Typical model for Inductance varies with turns
*      
*         Model name           turn          rad (um)
*                           low   high     low   high
*      ------------------------------------------------------
*         spiral_turn       2.5   7.5      60     60
*      ------------------------------------------------------
*         spiral_rad        4.5   4.5      30    150
*      ------------------------------------------------------   
*
*      **spiral_turn: only discret turn numbers are available,including 2.5, 3.5, 4.5, 5.5, 6.5 and 7.5
*      **spiral_rad: scaled by inner edge-to-edge radius, the details see SPICE document       
*
**************************************************************************************************

.subckt spiral_turn Top Bottom nr=2.5
* L = L(nr)
ls Top n2 '(0.40425*nr*nr-0.995*nr+2.3295)*1.0e-9*L_fac'
rs n2 Bottom '(1.029*nr-0.746)*rm6_fac'
cs Top Bottom '(6.243*nr+5.803)*1.0e-15*cs_fac'
cox1 Top n1 '(32.526*nr-14.405)*1.0e-15*cm6_fac'
cox2 Bottom n3 '(32.683*nr-25.194)*1.0e-15*cm6_fac'
csub1 n1 0 '(11.561*nr+9.1643)*1.0e-15*csub_fac'
csub2 n3 0 '(11.561*nr+9.1643)*1.0e-15*csub_fac'
rsub1 n1 0 '(-18.489*nr+487.7)*rsub_fac'
rsub2 n3 0 '(-18.489*nr+487.7)*rsub_fac'
.ends spiral_turn

.subckt spiral_rad Top Bottom rad=30u
* L = L(rad)
ls Top n2 '(0.0916*rad*1.0e6+0.7461)*1.0e-9*L_fac'
rs n2 Bottom '(0.031*rad*1.0e6+1.8553)*rm6_fac'
cs Top Bottom '(0.2289*rad*1.0e6+21.092)*1.0e-15*cs_fac'
cox1 Top n1 '(0.811*rad*1.0e6+79.292)*1.0e-15*cm6_fac'
cox2 Bottom n3 '(0.9108*rad*1.0e6+59.886)*1.0e-15*cm6_fac'
csub1 n1 0 '(0.1611*rad*1.0e6+50.779)*1.0e-15*csub_fac'
csub2 n3 0 '(0.1611*rad*1.0e6+50.779)*1.0e-15*csub_fac'
rsub1 n1 0 '(-0.575*rad*1.0e6+433.38)*rsub_fac'
rsub2 n3 0 '(-0.575*rad*1.0e6+433.38)*rsub_fac'
.ends spiral_rad

**************************************************************************************************
* 4) MOS VARACTOR MODEL :
*
*
*  HSPICE LEVEL 49:
*  
*     ## library files:
*     
*     The varactor are modeled with sub-circuit 'MOSCap_g3' and 'MOSCap_g6' 
*     for H98.4
*
*      
*      Model name    L(um)  Wf(um)   Side   Branch   Group
*      ----------------------------------------------------
*       MOSCap_g3     0.5    2        2      50       3           
*       MOSCap_g6     0.5    2        2      50       6
*      ----------------------------------------------------
*      
*      Following is a poly gate of a varactor which has 3 Groups, 5 Branches.
*      There are 2 Sides of Branches in per Group.
*      
*      --+----+----+--
*       -+-  -+-  -+-
*       -+-  -+-  -+-
*       -+-  -+-  -+- <<___Branch
*       -+-  -+-  -+-
*       -+-  -+-  -+-
*        ^
*        ^---Group
*
**************************************************************************************************
*
***************************************
*        Varactor's Group number=3    * 
***************************************
.subckt moscap_g3 Gate Bulk
.param dt='temper - 25'
.param Cgmin='0.95*(1+3.503e-4*dt+1.071e-5*(pow(dt,2)))*1.0e-12'
.param dCg='1.029*(1-6.564e-5*dt+1.836e-7*(pow(dt,2)))*1.0e-12 '
.param dVgs='-0.116*(1+1.814e-3*dt-8.909e-6*(pow(dt,2)))'
.param Vgnorm='0.456*(1+9.656e-4*dt-1.841e-6*(pow(dt,2)))'
Lgate Gate 3 '36.6e-12*L_fac'
Rgate 3 4 '0.7947*rnpolys_fac' 5.498e-3 8.1779e-6
Cgate 4 5 '(Cgmin+dCg*(1.0+tanh((v(4,5)-dVgs)/Vgnorm)))*cmv_fac'
Rch 5 2 1.4703 2.945e-3 2.9702e-5
Cov 5 2 147.5e-12
Csub 5 6 '30.2e-15*csub_fac'
Rsub 6 0 '21.1820*rsub_fac' 9.396e-3 -4.9267e-6
Rs 2 9 '0.7906*rm1_fac' 4.111e-3 3.9114e-6
Ls 9 Bulk '19.3e-12*L_fac'
.ends moscap_g3

***************************************
*        Varactor's Group number=6    * 
***************************************
.subckt moscap_g6 Gate Bulk
.param dt='temper - 25'
.param Cgmin='1.773*(1+3.464e-4*dt+8.918e-6*(pow(dt,2)))*1.0e-12'
.param dCg='1.934*(1+1.984e-4*dt-7.718e-7*(pow(dt,2)))*1.0e-12 '
.param dVgs='-0.114*(1+1.136e-3*dt-1.130e-5*(pow(dt,2)))'
.param Vgnorm='0.437*(1+6.151e-4*dt-3.071e-6*(pow(dt,2)))'
Lgate Gate 3 '87.5e-12*L_fac'
Rgate 3 4 '0.5166*rnpolys_fac' 9.581e-3 9.948e-6
Cgate 4 5 '(Cgmin+dCg*(1.0+tanh((v(4,5)-dVgs)/Vgnorm)))*cmv_fac'
Rch 5 2 1.7594 3.637e-3 6.212e-5
Cov 5 2 121.3e-12
Csub 5 6 '38.4e-15*csub_fac'
Rsub 6 0 '7.5895*rsub_fac' 1.388e-2 1.251e-4
Rs 2 9 '0.4106*rm1_fac' 4.018e-3 -1.351e-5
Ls 9 Bulk '37.5e-12*L_fac'
.ends moscap_g6

*
**************************************************************************************************
* 5)      Resistor type                     Subckt name      valid width(um)     valid squares   *
*                                                             min      max        min      max   *
*      N+ poly w/i silicide (0.18<=W<2.0)   rnpolys_rf        0.18     2.0         5       40    *
*      N+ poly w/i silicide (2.0<=W)        rnpolyl_rf        2.0      5.0         1       20    *
*      P+ poly w/i silicide (0.18<=W<2.0)   rppolys_rf        0.18     2.0         5       40    *
*      P+ poly w/i silicide (2.0<=W)        rppolyl_rf        2.0      5.0         1       20    *
*      N+ poly w/o silicide (W<=5.0)        rnpolywos_rf      2.0      5.0         5       10    *
*      N+ poly w/o silicide (5.0<W)         rnpolywol_rf      5.0     10.0         5       10    *
*      P+ poly w/o silicide (W<=5.0)        rppolywos_rf      2.0      5.0         5       10    *
*      P+ poly w/o silicide (5.0<W)         rppolywol_rf      5.0     10.0         5       10    *
*      N+ diff w/o silicide                 rnodwo_rf         2.0     10.0         5       10    *
*      P+ diff w/o silicide                 rpodwo_rf         2.0     10.0         5       10    *  
*      P- poly w/o silicide                 rppolyhri_rf      2.0     10.0         5       10    * 
**************************************************************************************************
*
.subckt rnpolys_rf Hi Lo l=1.8u w=0.18u
.param rsh=5.7 dw=-0.065u ptc1=2.92e-3 ptc2=2.66e-7 pvc1=1.35e-3 pvc2=7.15e-3 pt='temper'
.param tfac='1.0+ptc1*(pt-25.0)+ptc2*(pt-25.0)*(pt-25.0)'
rp Hi 5 'rsh*l/(w-dw)*(1+pvc1*abs(v(5,Hi))+pvc2*v(5,Hi)*v(5,Hi))*tfac*rnpolys_fac'
ls 5 Lo '(179.7194+(0.3243+2.5108*exp(-w*1e6/2.3465))*l*1e6)*1e-12*L_fac'
cov1 Hi 6 '26.8e-15*cpoly_fac'
rsub1 6 0 '2253*rsub_fac'
csub1 6 0 '3.5e-15*csub_fac'
rsub3 6 7 '1154*rnpolys_fac'
rsub2 7 0 '2253*rsub_fac'
csub2 7 0 '3.5e-15*csub_fac'
cov2 Lo 7 '26.8e-15*cpoly_fac'
.ends rnpolys_rf

.subckt rnpolyl_rf Hi Lo l=20u w=2u
.param rsh=7.4 dw=-0.065u ptc1=2.92e-3 ptc2=2.66e-7 pvc1=1.35e-3 pvc2=7.15e-3 pt='temper'
.param tfac='1.0+ptc1*(pt-25.0)+ptc2*(pt-25.0)*(pt-25.0)'
rp Hi 5 'rsh*l/(w-dw)*(1+pvc1*abs(v(5,Hi))+pvc2*v(5,Hi)*v(5,Hi))*tfac*rnpolyl_fac'
ls 5 Lo '(179.7194+(0.3243+2.5108*exp(-w*1e6/2.3465))*l*1e6)*1e-12*L_fac'
cov1 Hi 6 '14.49e-15*cpoly_fac'
rsub1 6 0 '2800*rsub_fac'
csub1 6 0 '2.822e-15*csub_fac'
rsub3 6 7 '2149*rnpolyl_fac'
rsub2 7 0 '2800*rsub_fac'
csub2 7 0 '2.822e-15*csub_fac'
cov2 Lo 7 '14.49e-15*cpoly_fac'
.ends rnpolyl_rf

.subckt rppolys_rf Hi Lo l=1.8u w=0.18u
.param rsh=6.7 dw=-0.051u ptc1=2.88e-3 ptc2=5.01e-7 pvc1=-7.89e-4 pvc2=6.19e-3 pt='temper'
.param tfac='1.0+ptc1*(pt-25.0)+ptc2*(pt-25.0)*(pt-25.0)'
rp Hi 5 'rsh*l/(w-dw)*(1+pvc1*abs(v(5,Hi))+pvc2*v(5,Hi)*v(5,Hi))*tfac*rppolys_fac'
ls 5 Lo '(173.9763+(0.3756+2.4009*exp(-w*1e6/2.3439))*l*1e6)*1e-12*L_fac'
cov1 Hi 6 '23.04e-15*cpoly_fac'
rsub1 6 0 '3367*rsub_fac'
csub1 6 0 '1.197e-15*csub_fac'
rsub3 6 7 '921.5*rppolys_fac'
rsub2 7 0 '3367*rsub_fac'
csub2 7 0 '1.197e-15*csub_fac'
cov2 Lo 7 '23.04e-15*cpoly_fac'
.ends rppolys_rf

.subckt rppolyl_rf Hi Lo l=20u w=2u
.param rsh=7.8 dw=-0.051u ptc1=2.88e-3 ptc2=5.01e-7 pvc1=-7.89e-4 pvc2=6.19e-3 pt='temper'
.param tfac='1.0+ptc1*(pt-25.0)+ptc2*(pt-25.0)*(pt-25.0)'
rp Hi 5 'rsh*l/(w-dw)*(1+pvc1*abs(v(5,Hi))+pvc2*v(5,Hi)*v(5,Hi))*tfac*rppolyl_fac'
ls 5 Lo '(173.9763+(0.3756+2.4009*exp(-w*1e6/2.3439))*l*1e6)*1e-12*L_fac'
cov1 Hi 6 '13.35e-15*cpoly_fac'
rsub1 6 0 '1968*rsub_fac'
csub1 6 0 '1.208e-15*csub_fac'
rsub3 6 7 '5859*rppolyl_fac'
rsub2 7 0 '1968*rsub_fac'
csub2 7 0 '1.208e-15*csub_fac'
cov2 Lo 7 '13.35e-15*cpoly_fac'
.ends rppolyl_rf

.subckt rnpolywos_rf Hi Lo l=10u w=5u
.param rx=1.477e-5 rgrain=37.16 rp=292 dl=0.07616e-6 dw=0.08333e-6 rc=7.8 nc=2
.param pt='temper'
.param pvcx1=3.785e-1 pvcx2=8.434e-6 pvcx3=-1.430 ptcx1=-2.278e-3 ptcx2=-21.29e-6
.param pvcp1=-2.843e-2 pvcp2=1.496e-5 pvcp3=-2.100 ptcp1=-1.102e-3 ptcp2=1.747e-6
.param pvcg1=2.527e-1 pvcg2=6.918e-6 pvcg3=-1.283 ptcg1=4.235e-3 ptcg2=-6.211e-6
.param tfacx='1.0+ptcx1*(pt-25.0)+ptcx2*(pt-25.0)*(pt-25.0)'
.param tfacp='1.0+ptcp1*(pt-25.0)+ptcp2*(pt-25.0)*(pt-25.0)'
.param tfacg='1.0+ptcg1*(pt-25.0)+ptcg2*(pt-25.0)*(pt-25.0)'
rg1 3 8 'rgrain*tfacg*(1+pvcg1*(tanh(pvcg2*abs(v(10,11)/(l-dl))+pvcg3)-tanh(pvcg3)))*rnpolywos_fac'
rint1 8 10 'rx/(w-dw)*tfacx*(1+pvcx1*(tanh(pvcx2*abs(v(10,11)/(l-dl))+pvcx3)-tanh(pvcx3)))*rnpolywos_fac'
rp 10 11 'rp*(l-dl)/(w-dw)*tfacp*(1+pvcp1*(tanh(pvcp2*abs(v(10,11)/(l-dl))+pvcp3)-tanh(pvcp3)))*rnpolywos_fac'
rint2 11 9 'rx/(w-dw)*tfacx*(1+pvcx1*(tanh(pvcx2*abs(v(10,11)/(l-dl))+pvcx3)-tanh(pvcx3)))*rnpolywos_fac' 
rg2 9 5 'rgrain*tfacg*(1+pvcg1*(tanh(pvcg2*abs(v(10,11)/(l-dl))+pvcg3)-tanh(pvcg3)))*rnpolywos_fac'
ls 5 4 '(0.2763-0.1451*w*1e6+0.0902*l*1e6-0.00805*w*l*1e12)*1e-9*L_fac'
rc1 Hi 3 'rc/nc'
cov1 Hi 6 '13.12e-15*cpoly_fac'
rsub1 6 0 '8209*rsub_fac'
csub1 6 0 '1.267e-15*csub_fac'
rsub3 6 7 '1066*rnpolywos_fac'
rsub2 7 0 '8209*rsub_fac'
csub2 7 0 '1.267e-15*csub_fac'
cov2 Lo 7 '13.12e-15*cpoly_fac'
rc2 4 Lo 'rc/nc'
.ends rnpolywos_rf

.subckt rnpolywol_rf Hi Lo l=10u w=5u
.param rx=1.477e-5 rgrain=37.16 rp=292 dl=0.07616e-6 dw=0.08333e-6 rc=7.8 nc=2
.param pt='temper'
.param pvcx1=3.785e-1 pvcx2=8.434e-6 pvcx3=-1.430 ptcx1=-2.278e-3 ptcx2=-21.29e-6
.param pvcp1=-2.843e-2 pvcp2=1.496e-5 pvcp3=-2.100 ptcp1=-1.102e-3 ptcp2=1.747e-6
.param pvcg1=2.527e-1 pvcg2=6.918e-6 pvcg3=-1.283 ptcg1=4.235e-3 ptcg2=-6.211e-6
.param tfacx='1.0+ptcx1*(pt-25.0)+ptcx2*(pt-25.0)*(pt-25.0)'
.param tfacp='1.0+ptcp1*(pt-25.0)+ptcp2*(pt-25.0)*(pt-25.0)'
.param tfacg='1.0+ptcg1*(pt-25.0)+ptcg2*(pt-25.0)*(pt-25.0)'
rg1 3 8 'rgrain*tfacg*(1+pvcg1*(tanh(pvcg2*abs(v(10,11)/(l-dl))+pvcg3)-tanh(pvcg3)))*rnpolywol_fac'
rint1 8 10 'rx/(w-dw)*tfacx*(1+pvcx1*(tanh(pvcx2*abs(v(10,11)/(l-dl))+pvcx3)-tanh(pvcx3)))*rnpolywol_fac'
rp 10 11 'rp*(l-dl)/(w-dw)*tfacp*(1+pvcp1*(tanh(pvcp2*abs(v(10,11)/(l-dl))+pvcp3)-tanh(pvcp3)))*rnpolywol_fac'
rint2 11 9 'rx/(w-dw)*tfacx*(1+pvcx1*(tanh(pvcx2*abs(v(10,11)/(l-dl))+pvcx3)-tanh(pvcx3)))*rnpolywol_fac' 
rg2 9 5 'rgrain*tfacg*(1+pvcg1*(tanh(pvcg2*abs(v(10,11)/(l-dl))+pvcg3)-tanh(pvcg3)))*rnpolywol_fac'
ls 5 4 '(1.3528-0.36028*w*1e6+0.03464*l*1e6+0.00307*w*l*1e12)*1e-9*L_fac'
rc1 Hi 3 'rc/nc'
cov1 Hi 6 '13.12e-15*cpoly_fac'
rsub1 6 0 '8209*rsub_fac'
csub1 6 0 '1.267e-15*csub_fac'                       
rsub3 6 7 '1640*rnpolywol_fac'                            
rsub2 7 0 '8209*rsub_fac'                            
csub2 7 0 '1.267e-15*csub_fac'                       
cov2 Lo 7 '13.12e-15*cpoly_fac'                        
rc2 4 Lo 'rc/nc'                          
.ends rnpolywol_rf

.subckt rppolywos_rf Hi Lo l=10u w=5u
.param rx=6.752e-5 rgrain=39.411 rp=311 dl=0.04696e-6 dw=0.06061e-6 rc=7.8 nc=2
.param pt='temper'
.param pvcx1=-1.311e-2 pvcx2=2.171e-5 pvcx3=-3.211 ptcx1=-1.790e-3 ptcx2=-7.245e-6
.param pvcp1=-5.405e-3 pvcp2=2.134e-5 pvcp3=-3.820 ptcp1=-13.80e-5 ptcp2=581.1e-9
.param pvcg1=6.667e-2 pvcg2=4.141e-6 pvcg3=0.140 ptcg1=2.979e-3 ptcg2=-2.295e-6
.param tfacx='1.0+ptcx1*(pt-25.0)+ptcx2*(pt-25.0)*(pt-25.0)'
.param tfacp='1.0+ptcp1*(pt-25.0)+ptcp2*(pt-25.0)*(pt-25.0)'
.param tfacg='1.0+ptcg1*(pt-25.0)+ptcg2*(pt-25.0)*(pt-25.0)'
rg1 3 8 'rgrain*tfacg*(1+pvcg1*(tanh(pvcg2*abs(v(10,11)/(l-dl))+pvcg3)-tanh(pvcg3)))*rppolywos_fac'
rint1 8 10 'rx/(w-dw)*tfacx*(1+pvcx1*(tanh(pvcx2*abs(v(10,11)/(l-dl))+pvcx3)-tanh(pvcx3)))*rppolywos_fac'
rp 10 11 'rp*(l-dl)/(w-dw)*tfacp*(1+pvcp1*(tanh(pvcp2*abs(v(10,11)/(l-dl))+pvcp3)-tanh(pvcp3)))*rppolywos_fac'
rint2 11 9 'rx/(w-dw)*tfacx*(1+pvcx1*(tanh(pvcx2*abs(v(10,11)/(l-dl))+pvcx3)-tanh(pvcx3)))*rppolywos_fac' 
rg2 9 5 'rgrain*tfacg*(1+pvcg1*(tanh(pvcg2*abs(v(10,11)/(l-dl))+pvcg3)-tanh(pvcg3)))*rppolywos_fac'
ls 5 4 '(1.285-0.754*w*1e6+0.28*l*1e6-0.03087*w*l*1e12)*1e-9*L_fac'
rc1 Hi 3 'rc/nc'
cov1 Hi 6 '15.61e-15*cpoly_fac'
rsub1 6 0 '5905*rsub_fac'
csub1 6 0 '1.278e-15*csub_fac'
rsub3 6 7 '766.3*rppolywos_fac'
rsub2 7 0 '5905*rsub_fac'
csub2 7 0 '1.278e-15*csub_fac'
cov2 Lo 7 '15.61e-15*cpoly_fac'
rc2 4 Lo 'rc/nc'
.ends rppolywos_rf

.subckt rppolywol_rf Hi Lo l=10u w=5u
.param rx=6.752e-5 rgrain=39.411 rp=311 dl=0.04696e-6 dw=0.06061e-6 rc=7.8 nc=2
.param pt='temper'
.param pvcx1=-1.311e-2 pvcx2=2.171e-5 pvcx3=-3.211 ptcx1=-1.790e-3 ptcx2=-7.245e-6
.param pvcp1=-5.405e-3 pvcp2=2.134e-5 pvcp3=-3.820 ptcp1=-13.80e-5 ptcp2=581.1e-9
.param pvcg1=6.667e-2 pvcg2=4.141e-6 pvcg3=0.140 ptcg1=2.979e-3 ptcg2=-2.295e-6
.param tfacx='1.0+ptcx1*(pt-25.0)+ptcx2*(pt-25.0)*(pt-25.0)'
.param tfacp='1.0+ptcp1*(pt-25.0)+ptcp2*(pt-25.0)*(pt-25.0)'
.param tfacg='1.0+ptcg1*(pt-25.0)+ptcg2*(pt-25.0)*(pt-25.0)'
rg1 3 8 'rgrain*tfacg*(1+pvcg1*(tanh(pvcg2*abs(v(10,11)/(l-dl))+pvcg3)-tanh(pvcg3)))*rppolywol_fac'
rint1 8 10 'rx/(w-dw)*tfacx*(1+pvcx1*(tanh(pvcx2*abs(v(10,11)/(l-dl))+pvcx3)-tanh(pvcx3)))*rppolywol_fac'
rp 10 11 'rp*(l-dl)/(w-dw)*tfacp*(1+pvcp1*(tanh(pvcp2*abs(v(10,11)/(l-dl))+pvcp3)-tanh(pvcp3)))*rppolywol_fac'
rint2 11 9 'rx/(w-dw)*tfacx*(1+pvcx1*(tanh(pvcx2*abs(v(10,11)/(l-dl))+pvcx3)-tanh(pvcx3)))*rppolywol_fac' 
rg2 9 5 'rgrain*tfacg*(1+pvcg1*(tanh(pvcg2*abs(v(10,11)/(l-dl))+pvcg3)-tanh(pvcg3)))*rppolywol_fac'
ls 5 4 '(-2.261+0.1785*l*1e6-0.0106*w*l*1e12)*1e-9*L_fac'
rc1 Hi 3 'rc/nc'
cov1 Hi 6 '15.61e-15*cpoly_fac'
rsub1 6 0 '5905*rsub_fac'
csub1 6 0 '1.278e-15*csub_fac'
rsub3 6 7 '1744*rppolywol_fac'
rsub2 7 0 '5905*rsub_fac'
csub2 7 0 '1.278e-15*csub_fac'
cov2 Lo 7 '15.61e-15*cpoly_fac'
rc2 4 Lo 'rc/nc'
.ends rppolywol_rf

.subckt rnodwo_rf Hi Lo l=10u w=2u
.param rsh=59 dw=0.0u ptc1=1.47e-3 ptc2=8.32e-7 pvc1=7.55e-4 pvc2=1.97e-4 pt='temper'
.param tfac='1.0+ptc1*(pt-25.0)+ptc2*(pt-25.0)*(pt-25.0)'
rp Hi 5 'rsh*l/(w-dw)*(1+pvc1*abs(v(Hi,5))+pvc2*v(Hi,5)*v(Hi,5))*tfac*rnodwo_fac'
ls 5 Lo '(156.525-35.11*w*1e6-1.581*l*1e6+1.158*w*l*1e12)*1e-12*L_fac'
cov1 Hi 6 '(13.7225+3.84875*w*1e6)*1e-15*cj_fac'
rsub1 6 0 '(4.6515-0.22125*w*1e6)*1e3*rsub_fac'
csub1 6 0 '(3.77875-0.12388*w*1e5)*1e-15*csub_fac'
rsub3 6 7 '(1320.6-43.3*w*1e6)*rnodwo_fac'
rsub2 7 0 '(4.6515-0.22125*w*1e6)*1e3*rsub_fac'
csub2 7 0 '(3.77875-0.12388*w*1e5)*1e-15*csub_fac'
cov2 Lo 7 '(13.7225+3.84875*w*1e6)*1e-15*cj_fac'
.ends rnodwo_rf

.subckt rpodwo_rf Hi Lo l=10u w=2u
.param rsh=133 dw=0.00u ptc1=1.43e-3 ptc2=7.82e-7 pvc1=-1.19e-3 pvc2=-1.80e-4 pt='temper'
.param tfac='1.0+ptc1*(pt-25.0)+ptc2*(pt-25.0)*(pt-25.0)'
rp Hi 5 'rsh*l/(w-dw)*(1+pvc1*abs(v(Hi,5))+pvc2*v(Hi,5)*v(Hi,5))*tfac*rpodwo_fac'
ls 5 Lo '(157.43-105.66*w*1e6+14.76*l*1e6+2.205*w*l*1e12)*1e-12*L_fac'
cov1 Hi 6 '(8.945+6.2075*w*1e6)*1e-15*cj_fac'
rsub1 6 0 '(4.83425-0.20163*w*1e6)*1e3*rsub_fac'
csub1 6 0 '(1.19725+0.00138*w*1e5)*1e-15*csub_fac'
rsub3 6 7 '(772.875-3.2875*w*1e6)*rpodwo_fac'
rsub2 7 0 '(4.83425-0.20163*w*1e6)*1e3*rsub_fac'
csub2 7 0 '(1.19725+0.00138*w*1e5)*1e-15*csub_fac'
cov2 Lo 7 '(8.945+6.2075*w*1e6)*1e-15*cj_fac'
.ends rpodwo_rf


.subckt rppolyhri_rf Hi Lo l=10u w=2u
.param pt='temper' dl=7e-7
.param Rx0=71.703 pvcx1=0.1493 pvcx2=2.995e-5 pvcx3=-1.108 ptcx1=1.012e-3 ptcx2= 3.982e-6
.param Rend0=5.8953e-5 pvce1=5.056e-2 pvce2=6.6e-5 pvce3=-0.1633 ptce1=-2.488e-3 ptce2= -5.564e-6
.param Rsh=1075.365 pvcp1=-0.1915 pvcp2=2.12e-6 pvcp3=-1.606 ptcp1=-1.056e-3 ptcp2= 2.931e-6
.param dw0=8.935746e-8 dw1=1.271723 dw2=1.944573e-6 dw3=-1.583278 
.param tfacx='1.0+ptcx1*(pt-25.0)+ptcx2*(pt-25.0)*(pt-25.0)'
.param tface='1.0+ptce1*(pt-25.0)+ptce2*(pt-25.0)*(pt-25.0)'
.param tfacp='1.0+ptcp1*(pt-25.0)+ptcp2*(pt-25.0)*(pt-25.0)'
.param dwj='dw0*(1.0+dw1*(tanh(dw2*abs(v(5,4))/(l-dl)+dw3)-tanh(dw3)))'
Rx1   Hi 1 'Rx0*tfacx*(1.0+pvcx1*(tanh(pvcx2*abs(v(Hi,1))/(w-dwj)+pvcx3)-tanh(pvcx3)))*rppolyhri_fac'
Rend1 3 5 'Rend0/(w-dwj)*tface*(1.0+pvce1*(tanh(pvce2*abs(v(3,5))+pvce3)-tanh(pvce3)))*rppolyhri_fac'
Rpure 5 4 'Rsh*(l-dl)/(w-dwj)*tfacp*(1.0+pvcp1*(tanh(pvcp2*abs(v(5,4))/(l-dl)+pvcp3)-tanh(pvcp3)))*rppolyhri_fac'
Rend2 4 2 'Rend0/(w-dwj)*tface*(1.0+pvce1*(tanh(pvce2*abs(v(4,2))+pvce3)-tanh(pvce3)))*rppolyhri_fac'
Rx2 2 Lo 'Rx0*tfacx*(1.0+pvcx1*(tanh(pvcx2*abs(v(2,Lo))/(w-dwj)+pvcx3)-tanh(pvcx3)))*rppolyhri_fac'
ls  1 3 '0.747*l*1e6*exp(-0.01766*w*1e6)*1e-12*L_fac'
cov1 Hi 6 '(16.24+0.32*w*1e6-0.108*l*1e6)*1e-15*cpoly_fac'
rsub1 6 0 '480000/l/1e6*rsub_fac'
csub1 6 0 '(1.85+0.0003018*w*l*1e12)*1e-15*csub_fac'
rsub3 6 7 '(20.2*l*1e6+866/w/1e6)*rppolyhri_fac'
rsub2 7 0 '480000/l/1e6*rsub_fac'
csub2 7 0 '(1.85+0.0003018*w*l*1e12)*1e-15*csub_fac'
cov2 Lo 7 '(16.24+0.32*w*1e6-0.108*l*1e6)*1e-15*cpoly_fac'
.ends rppolyhri_rf


**************************************************************************************
* 6) JUCTION VARACTOR model                                                           
*                                                                                     
*	The Juction Varactor modle is a scalable model with capacitance	ranged from   
*	0.33 pF to 1.8 pF.                                                            
*										      
*         Model name      L (um)       W (um)         nr
*                                                 low   high
*      ---------------------------------------------------------
*         xjvar            0.42          40        12    50
*      ---------------------------------------------------------
*            **L: finger length
*            **W: finger width
*            **nr: finger number
*                                                                                                                                                                         
************************************************************************************** 
.subckt xjvar Anode Cathode  nr=12
.param area_d2='41.4e-12*(1.4*nr+1.59)'                          
.param peri_d2='2.8e-6*nr+85.981e-6'  
D1    3 4   pdio_xj  m=nr
Ls1   Anode 3   '(0.2627*nr+96.881)*1.0e-12*L_fac'
Rl1   Anode 3  '(-0.5255*nr+76.239)*rm1_fac'
Ls2   4 Cathode  '(0.2627*nr+66.881)*1.0e-12*L_fac'
Rl2   4 Cathode  '(-0.5255*nr+81.239)*rm1_fac'
Cp    Anode 0  2.5e-15
D2    5 4   nwdio_xj  AREA=area_d2  PJ=peri_d2
Rsub1 5 0  '(-0.3954*nr+54.8)*rsub_fac'
.ends xjvar

.lib 'rf018.l' DIO_XJVAR

**************************************************************************************************
* 7) LCESD model  for Low-Capacitance ESD  
**************************************************************************************************
.SUBCKT LCESD_rf ANODE

R1 ANODE 1  2.5
D1 2 1  NWDIO_ESD area=24.33p PJ=25.98u m=2
Rsub1 2 0  167.2
Csub1 2 0  50f
D2 1 3 PDIO_ESD area=67.8p PJ=64.52u
D3 4 3 NWDIO_ESD area=86.44p PJ=68.16u
Rsub2 4 0  103.5
Csub2 4 0  30.99f
.ENDs LCESD_rf 

.lib 'rf018.l' DIO_ESD

.ENDL RF_MACRO


***************************************************************
*                                                             *
*               1.8V NORMAL DEVICES MODEL                     *
*                                                             *
***************************************************************
.LIB MOS_RF                     
***************************************************************
*              1.8V NMOS DEVICES                              *
***************************************************************
.MODEL nch_rf            NMOS  (                       
+LMIN   = 1.8E-07  LMAX    = 5E-07   WMIN  = 2.5E-06    WMAX     = 2.5E-06   
+Noimod = 1          AF    = 1.021     EF  = 0.874      KF       = 2.69E-28
+LEVEL    = 49             TNOM     = 25             VERSION  = 3.2            
+TOX      = '4.08E-09*nmos_toxfac'            
+TOXM     = '4.08E-09*nmos_toxfac'            XJ       = 1.6000000E-07       
+NCH      = 3.9000000E+17       LLN      = 1.0000000           LWN      = 1.0000000           
+WLN      = 1.0000000           WWN      = 1.0000000           LINT     = 1.0000000E-08       
+LL       = 0.00                LW       = 0.00                LWL      = 0.00                
+WINT     = 1.0000000E-08       WL       = 0.00                WW       = 0.00                
+WWL      = 0.00                MOBMOD   = 1                   BINUNIT  = 2                   
+XL       = '-2E-08*nmos_dlfac' XW       = '1E-6*nmos_dwfac'   LMLT     = 1                   
+WMLT     = 1                   BINFLAG  = 0                   DWG      = 0.00                
+DWB      = 0.00                
* DIODE PARAMETERS
+ACM      = 12                  LDIF     = 9.00E-08            HDIF     = 2.00E-07            
+RSH      = 6.8                 RD       = 0                   RS       = 0                   
+RSC      = 0                   RDC      = 0                                      
*
* THRESHOLD VOLTAGE PARAMETERS
*
+VTH0     = '0.4751247*nmos_vthfac'
+LVTH0    = 5.3063760E-09       WVTH0    = 1.0620770E-09       
+PVTH0    = 5.1808260E-15       K1       = '0.3998241*nmos_k1fac'
+LK1      = 4.9644130E-08       
+WK1      = 9.7659690E-08       PK1      = -6.4727410E-15      K2       = 6.3521660E-02       
+LK2      = -2.3884111E-08      WK2      = -4.2037990E-08      PK2      = 5.4169450E-15       
+K3       = 0.00                DVT0     = 0.00                DVT1     = 0.00                
+DVT2     = 0.00                DVT0W    = 0.00                DVT1W    = 0.00                
+DVT2W    = 0.00                NLX      = 0.00                W0       = 0.00                
+K3B      = 0.00                NGATE    = 0.00                VFB      = 99.0000000          
*
* MOBILITY PARAMETERS
*
+VSAT     = 8.4292200E+04       LVSAT    = -2.0125000E-04      WVSAT    = 1.4661819E-03       
+UA       = -9.0576310E-10      LUA      = 4.2158860E-18       WUA      = 4.6750410E-16       
+PUA      = -5.2584610E-23      UB       = 2.7604860E-18       LUB      = 5.4007650E-27       
+WUB      = -1.0208560E-24      PUB      = 1.5842940E-33       UC       = 1.2342530E-10       
+LUC      = 4.2403960E-18       WUC      = -6.6307350E-17      PUC      = -1.0627700E-24      
+RDSW     = '170*nmos_rdswfac'  PRWB     = 0.00                PRWG     = 0.00                
+WR       = 1.0000000           U0       = '0.04387662*nmos_uefffac'
+LU0      = 1.2834320E-09       
+WU0      = -5.2111120E-09      PU0      = -3.1569641E-16      A0       = 0.5262759           
+LA0      = 8.2773920E-08       WA0      = 1.4472550E-07       PA0      = -7.3065910E-14      
+KETA     = -4.4286950E-02      LKETA    = 3.2422730E-09       WKETA    = 2.4587580E-08       
+PKETA    = -2.8367999E-15      A1       = 0.00                A2       = 0.9900000           
+AGS      = -2.8363639E-02      LAGS     = 1.1709090E-09       WAGS     = 8.4305460E-08       
+PAGS     = -1.1802760E-14      B0       = 0.00                B1       = 0.00                
*
* SUBTHRESHOLD CURRENT PARAMETERS
*
+VOFF     = -0.1246745          LVOFF    = -1.4680270E-09      WVOFF    = 1.2453290E-09       
+PVOFF    = -7.8193100E-16      NFACTOR  = 1.0000000           CIT      = 2.7566159E-04       
+LCIT     = 1.0319570E-10       WCIT     = -3.7646720E-11      PCIT     = 1.7317489E-17       
+CDSC     = 0.00                CDSCB    = 0.00                CDSCD    = 0.00                
+ETA0     = -2.9375000E-04      LETA0    = 1.8112500E-10       ETAB     = 1.3875000E-03       
+LETAB    = -6.8425000E-10      DSUB     = 0.00                
*
* ROUT PARAMETERS
*
+PCLM     = 1.1025569           LPCLM    = 3.8132860E-08       WPCLM    = 5.1117520E-08       
+PPCLM    = 4.3930240E-14       PDIBLC1  = 1.0000000E-06       PDIBLC2  = -6.1465890E-03      
+LPDIBLC2 = 5.0605220E-09       WPDIBLC2 = 2.1076341E-09       PPDIBLC2 = -2.9506861E-16      
+PDIBLCB  = 1.0000000E-02       DROUT    = 0.00                PSCBE1   = 4.0000000E+08       
+PSCBE2   = 1.0000000E-06       PVAG     = 0.00                DELTA    = 1.0000000E-02       
+ALPHA0   = 0                   ALPHA1   = 0.429               BETA0    = 11.5926300          
*
* TEMPERATURE EFFECTS PARAMETERS
*
+KT1      = -0.2268918          LKT1     = 5.1277220E-09       WKT1     = -2.5768780E-09      
+PKT1     = -2.0873759E-15      KT2      = -2.9372420E-02      LKT2     = 6.0691700E-10       
+WKT2     = -1.6500700E-09      PKT2     = -3.9361900E-17      AT       = 2.0000000E+04       
+UTE      = -2.1724229          LUTE     = 8.3695030E-08       WUTE     = 9.0012740E-07       
+PUTE     = -1.3363610E-13      UA1      = 1.2174139E-09       LUA1     = 9.2209620E-19       
+WUA1     = 8.4305930E-18       PUA1     = -1.1802830E-24      UB1      = -3.8522240E-18      
+LUB1     = 4.3064910E-25       WUB1     = 3.2489980E-24       PUB1     = -4.8142620E-31      
+UC1      = -1.5688140E-10      LUC1     = 3.2866920E-17       WUC1     = 1.8689849E-16       
+PUC1     = -3.2542850E-23      KT1L     = 0.00                PRT      = 0.00                
*
* CAPACITANCE PARAMETERS
*
+CJ       = 1.000266E-06        MJ       = 0.3595262           PB       = 0.6882682           
+CJSW     = 2.040547E-13        MJSW     = 0.2003879           PBSW     = 0.6882682           
+CJSWG    = 3.340547E-13        MJSWG    = 0.43879             PBSWG    = 0.6882682           
+TPB      = 1.554306E-03        TPBSW    = 1.554306E-03        TCJ      = 1.040287E-03        
+TCJSW    = 6.45489E-04         JS       = 8.38E-06            JSW      = 1.60E-11            
+NJ       = 1.0                 XTI      = 3.0                 CGDO     = '3.4367E-10*nmos_cgdfac'          
+CGSO     = '4.317E-10*nmos_cgdfac'   
+CGBO     = 1.0E-13             CAPMOD   = 3                   
+NQSMOD   = 0                   ELM      = 0                   XPART    = 0
+CF      = 0              TLEV     = 1              TLEVC    = 1              
+CALCACM = 1               
*********added AC parameters*****
+NOFF=1.2 
+CLE=1 CLC=1.45e-8
+DLC=4.6433e-8 Llc= -0.123E-14 
+VOFFCV= 0.1261 LVOFFCV= -0.0094E-6 
+CGSL='6.6175e-10*nmos_cgdfac' LCGSL= -0.3804E-16
+CGDL='2.4366e-10*nmos_cgdfac' LCGDL= -0.175E-16 )

***************************************************************
*              1.8V PMOS DEVICES                              *
***************************************************************
*
*
.MODEL pch_rf         PMOS  (  
+LMIN     = 1.8E-07        
+LMAX    = 5E-07    WMIN     = 2.5E-06  WMAX     = 2.5E-06
+Noimod = 1          AF    = 1.369     EF  = 1.064      KF  = 5.77E-27
+LEVEL   = 49             TNOM     = 25             VERSION  = 3.2            
+TOX      = '4.08E-09*pmos_toxfac'     
+TOXM     = '4.08E-09*pmos_toxfac'            XJ       = 1.7000001E-07       
+NCH      = 3.9000000E+17       LLN      = 1.0000000           LWN      = 1.0000000           
+WLN      = 1.0000000           WWN      = 1.0000000           LINT     = 1.4999999E-08       
+LL       = 0.00                LW       = 0.00                LWL      = 0.00                
+WINT     = 1.4999999E-08       WL       = 0.00                WW       = 0.00                
+WWL      = 0.00                MOBMOD   = 1                   BINUNIT  = 2                   
+XL       = '-2E-08*pmos_dlfac'
+XW       = '1e-6*pmos_dwfac'   LMLT     = 1                   
+WMLT     = 1                   BINFLAG  = 0                   DWG      = 0.00                
+DWB      = 0.00                
* DIODE PARAMETERS
+ACM      = 12                  LDIF     = 9.00E-08            HDIF     = 2.00E-07            
+RSH      = 7.2                 RD       = 0                   RS       = 0                   
+RSC      = 0                   RDC      = 0                                      
*
* THRESHOLD VOLTAGE PARAMETERS
*
+VTH0     = '-0.4493721*pmos_vthfac'
+LVTH0    = -8.0657600E-09      WVTH0    = 1.0679620E-08       
+PVTH0    = -1.7425970E-15      K1       = '0.5178921*pmos_k1fac'
+LK1      = 1.8871200E-08       
+WK1      = 1.4451329E-07       PK1      = -2.0570920E-14      K2       = 4.2809810E-02       
+LK2      = -6.7585580E-09      WK2      = -5.2837130E-08      PK2      = 8.7969570E-15       
+K3       = 0.00                DVT0     = 0.00                DVT1     = 0.00                
+DVT2     = 0.00                DVT0W    = 0.00                DVT1W    = 0.00                
+DVT2W    = 0.00                NLX      = 0.00                W0       = 0.00                
+K3B      = 0.00                NGATE    = 0.00                VFB      = 99.0000000          
*
* MOBILITY PARAMETERS
*
+VSAT     = 1.3081250E+05       LVSAT    = -3.6562360E-04      UA       = 9.4992950E-10       
+LUA      = -1.7850020E-16      WUA      = -7.6798820E-16      PUA      = 1.8454060E-22       
+UB       = 4.958583E-19       LUB      = 1.3731120E-25       WUB      = 4.3796020E-25       
+PUB      = -1.5285560E-31      UC       = -1.5879040E-10      LUC      = 1.9585860E-17       
+WUC      = 2.9227921E-17       PUC      = -1.0819630E-23      RDSW     = '530*pmos_rdswfac'       
+PRWB     = 0.00                PRWG     = 0.00                WR       = 1.0000000           
+U0       = '0.009831898*pmos_uefffac'
+LU0      = -1.2916450E-10      WU0      = -2.9276901E-09      
+PU0      = 3.0125661E-16       A0       = 1.2734300           LA0      = 3.3696850E-09       
+WA0      = -5.0017450E-07      PA0      = 1.2788430E-13       KETA     = 1.5000610E-02       
+LKETA    = -5.8313550E-10      WKETA    = 8.6611480E-09       PKETA    = -2.4688039E-15      
+A1       = 0.00                A2       = 0.4000000           AGS      = 2.0000000E-02       
+B0       = 0.00                B1       = 0.00                
*
* SUBTHRESHOLD CURRENT PARAMETERS
*
+VOFF     = -0.1308178          LVOFF    = 1.5542660E-10       WVOFF    = 5.5181630E-09       
+PVOFF    = -1.9057119E-15      NFACTOR  = 1.0000000           CIT      = -6.2808550E-05      
+LCIT     = 1.1818900E-10       WCIT     = 2.2197810E-10       PCIT     = -8.5542230E-17      
+CDSC     = 0.00                CDSCB    = 0.00                CDSCD    = 0.00                
+ETA0     = -4.6875020E-04      LETA0    = 2.5593749E-10       ETAB     = 1.1367541E-03       
+LETAB    = -5.5653940E-10      WETAB    = -5.9039650E-10      PETAB    = 2.6567850E-16       
+DSUB     = 0.00                
*
* ROUT PARAMETERS
*
+PCLM     = 0.9115400           LPCLM    = 3.9806980E-08       WPCLM    = -1.3100870E-08      
+PPCLM    = 5.8953990E-15       PDIBLC1  = 1.0000000E-06       PDIBLC2  = 7.9687500E-03       
+LPDIBLC2 = 9.1406240E-10       PDIBLCB  = 1.0000000E-02       DROUT    = 0.00                
+PSCBE1   = 3.5000000E+08       PSCBE2   = 5.0000000E-07       PVAG     = 0.00                
+DELTA    = 1.0000000E-02       ALPHA0   = 0                   ALPHA1   = 6.56                
+BETA0    = 22.6782700          
*
* TEMPERATURE EFFECTS PARAMETERS
*
+KT1      = -0.2368895          LKT1     = -2.4634870E-09      WKT1     = 2.0141179E-08       
+PKT1     = -2.0090080E-15      KT2      = -2.5679991E-02      LKT2     = -7.6223150E-11      
+WKT2     = 8.0890460E-09       PKT2     = -1.5586480E-15      AT       = 1.0000000E+04       
+UTE      = -0.7213691          LUTE     = 5.3870080E-10       WUTE     = 1.2306521E-07       
+PUTE     = 1.0594620E-14       UA1      = 1.2240000E-09       UB1      = -1.3525320E-18      
+LUB1     = 2.5492080E-26       WUB1     = -2.5754361E-25      PUB1     = 3.3378430E-32       
+UC1      = 7.1914950E-11       LUC1     = -7.8692750E-18      WUC1     = -4.9637810E-17      
+PUC1     = 1.0194490E-23       KT1L     = 0.00                PRT      = 0.00                
*
* CAPACITANCE PARAMETERS
*
+CJ       = 1.121E-06           MJ       = 0.4476              PB       = 0.895226            
+CJSW     = 2.481E-13           MJSW     = 0.3683619           PBSW     = 0.895226            
+CJSWG    = 4.221E-13           MJSWG    = 0.3683619           PBSWG    = 0.895226            
+TPB      = 1.572025E-03        TPBSW    = 1.572025E-03        TCJ      = 9.739001E-04        
+TCJSW    = 4.130718E-04        JS       = 4.92E-06            JSW      = 9.00E-10            
+NJ       = 1.0                 XTI      = 3.0                 CGDO     = '3.53E-10*pmos_cgdfac'            
+CGSO     = '3.56E-10*pmos_cgdfac'        
+CGBO     = 1.0E-13             CAPMOD   = 3                   
+NQSMOD   = 0                   ELM      = 0                   XPART    = 0                   
+CF       = 0              
+TLEV    = 1              TLEVC    = 1              CALCACM  = 1              
*+SFVTFLAG= 0             VFBFLAG  = 1              
*********added AC parameters*****
+NOFF=0.75 
+CKAPPA=0.8 
+CLE=1 CLC=2.5e-10    
+VOFFCV=0.1894 LVOFFCV= -0.0172E-6
+CGSL='3.982e-10*pmos_cgdfac'  LCGSL= -0.2830E-16
+CGDL='3.72e-10*pmos_cgdfac'  LCGDL= -0.2324E-16
+DLC=5.75e-8  Llc= -0.348E-14 )

*
.ENDL MOS_RF                                    
*
.LIB DIO_RF
*
***************************************************************
*                    1.8V MODEL OF N+/PW DIODE                *
***************************************************************   
.MODEL ndio_rf_f D (
+LEVEL = 1
+TLEVC=1
+ CJ='0.002000266*ndio_cjfac' 
+ MJ=0.3595262
+ PB=0.6882682
+ CJSW='4.040547E-10*ndio_cjfac'
+ MJSW=0.2003879
+ PHP=0.6882682
+CTA=0.001040287
+CTP=0.000645489 
+TPB=0.001554306
+TPHP=0.001554306 )
********** diode gate edge ***************
.MODEL ndio_rf_g D (
+LEVEL = 1
+TLEVC=1
+ CJ='0.001000266*ndio_cjfac' 
+ MJ=0.3595262
+ PB=0.6882682
+ CJSW='4.340547E-10*ndio_cjfac'
+ MJSW=0.43879
+ PHP=0.6882682
+CTA=0.001040287
+CTP=0.000645489 
+TPB=0.001554306
+TPHP=0.001554306 )
                                               
***************************************************************
*                    1.8V MODEL OF P+/NW DIODE                *
***************************************************************
********* field edge diode *******
.MODEL pdio_rf_f D (
+LEVEL = 1
+TLEVC=1
+ CJ='0.00163*pdio_cjfac'
+ MJ=0.4476
+ PB=0.895226
+ CJSW='3.581E-10*pdio_cjfac'
+ MJSW=0.3683619
+ PHP=0.895226
+CTA=0.0009739001
+CTP=0.0004130718
+TPB=0.001572025
+TPHP=0.001572025 )
****** gate edge diode *********
.MODEL pdio_rf_g D (
+LEVEL = 1
+TLEVC=1
+ CJ='0.00149*pdio_cjfac'
+ MJ=0.4476
+ PB=0.895226
+ CJSW='3.921E-10*pdio_cjfac'
+ MJSW=0.3683619
+ PHP=0.895226
+CTA=0.0009739001
+CTP=0.0004130718
+TPB=0.001572025
+TPHP=0.001572025 )
*                                                   
.ENDL DIO_RF
*
***************************************************************
*                                                             *
*              3.3V MOS DEVICES MODEL                         *
*                                                             *
***************************************************************
.LIB MOS_RF33
***************************************************************
*             3.3V NMOS DEVICES                               *
***************************************************************
.MODEL nch_rf33            NMOS (  
+LMIN     = 3.5E-07        
+Noimod = 1          AF    = 0.926     EF  = 0.881      KF       = 2.02E-28
+LMAX    = 5E-07   WMIN     = 2.5E-06     WMAX    = 2.5E-06      
+LEVEL   = 49             TNOM     = 25             VERSION  = 3.2            
+TOX      = '6.8E-09*nmos_toxfac'            TOXM     = '6.8E-09*nmos_toxfac'
+XJ       = 1.7000001E-07       
+NCH      = 5.2600000E+17       LLN      = 1.0000000           LWN      = 1.0000000           
+WLN      = 1.0000000           WWN      = 1.0000000           LINT     = 4.0000000E-08       
+LL       = 0.00                LW       = 0.00                LWL      = 0.00                
+WINT     = 2.9999999E-08       WL       = 0.00                WW       = 0.00                
+WWL      = 0.00                MOBMOD   = 1                   BINUNIT  = 2                   
+XL       = '-2E-08*nmos_dlfac' XW       = '1e-6*nmos_dwfac'   LMLT     = 1                   
+WMLT     = 1                   BINFLAG  = 0                   DWG      = 0.00                
+DWB      = 0.00                
* DIODE PARAMETERS
+ACM      = 12                  LDIF     = 9.00E-08            HDIF     = 2.00E-07            
+RSH      = 6.8                 RD       = 0                   RS       = 0                   
+RSC      = 0                   RDC      = 0                                      
*
* THRESHOLD VOLTAGE PARAMETERS
*
+VTH0     = '0.8654908*nmos_vthfac'
+LVTH0    = -1.6563961E-08      WVTH0    = 1.4226810E-09       
+PVTH0    = -6.0851740E-16      K1       = '0.7481822*nmos_k1fac'
+LK1      = 1.0296160E-07       
+WK1      = -1.0085570E-07      PK1      = 2.0070249E-14       K2       = 0.1897030           
+LK2      = -9.3662770E-08      WK2      = 8.4660090E-09       PK2      = 7.5449070E-15       
+K3       = 0.00                DVT0     = 0.00                DVT1     = 0.00                
+DVT2     = 0.00                DVT0W    = 0.00                DVT1W    = 0.00                
+DVT2W    = 0.00                NLX      = 0.00                W0       = 0.00                
+K3B      = 0.00                NGATE    = 0.00                VFB      = 99.0000000          
*
* MOBILITY PARAMETERS
*
+VSAT     = 9.3128790E+04       LVSAT    = -8.5151520E-04      WVSAT    = -4.6304550E-03      
+PVSAT    = 1.8521820E-09       UA       = -6.6653380E-10      LUA      = -9.5332020E-17      
+WUA      = -1.0028990E-15      PUA      = 3.9566900E-22       UB       = 2.1159180E-18       
+LUB      = 2.1872130E-25       WUB      = 5.4583600E-25       PUB      = -4.3931030E-31      
+UC       = 2.6312810E-10       LUC      = -3.9061290E-17      WUC      = -1.2045420E-16      
+PUC      = 2.9778029E-23       RDSW     = '545*nmos_rdswfac'  PRWB     = 0.00                
+PRWG     = 0.00                WR       = 1.0000000           U0       = '0.04367778*nmos_uefffac'       
+LU0      = 3.7708480E-10       WU0      = -1.0239110E-08      PU0      = 2.6671971E-15       
+A0       = 0.8783571           LA0      = -7.1820300E-08      WA0      = 1.1142880E-07       
+PA0      = -3.1817270E-14      KETA     = -5.3438060E-02      LKETA    = 7.3436540E-09       
+WKETA    = -4.7415920E-08      PKETA    = 2.0938200E-14       A1       = 0.00                
+A2       = 0.9900000           AGS      = -2.0000000E-02      B0       = 0.00                
+B1       = 0.00                
*
* SUBTHRESHOLD CURRENT PARAMETERS
*
+VOFF     = -0.1005511          LVOFF    = -3.7765370E-09      WVOFF    = -3.9807150E-09      
+PVOFF    = 5.9385570E-15       NFACTOR  = 1.0000000           CIT      = 4.8792270E-04       
+LCIT     = 6.6982590E-12       WCIT     = 3.2627760E-11       PCIT     = -1.1425240E-17      
+CDSC     = 0.00                CDSCB    = 0.00                CDSCD    = 0.00                
+ETA0     = -1.1666670E-03      LETA0    = 6.6666670E-10       ETAB     = 3.7821970E-03       
+LETAB    = -1.7128789E-09      WETAB    = -1.1576140E-09      PETAB    = 4.6304560E-16       
+DSUB     = 0.00                
*
* ROUT PARAMETERS
*
+PCLM     = -0.2016089          LPCLM    = 3.5852410E-07       WPCLM    = 5.8573180E-07       
+PPCLM    = -1.3663259E-13      PDIBLC1  = 1.0000000E-06       PDIBLC2  = -1.1359850E-02      
+LPDIBLC2 = 4.9439400E-09       WPDIBLC2 = 6.9456830E-09       PPDIBLC2 = -2.7782729E-15      
+PDIBLCB  = 1.0000000E-02       DROUT    = 0.00                PSCBE1   = 3.5000000E+08       
+PSCBE2   = 1.0000000E-06       PVAG     = 0.00                DELTA    = 1.0000000E-02       
+ALPHA0   = 0                   ALPHA1   = 6.88                BETA0    = 21.5673010          
*
* TEMPERATURE EFFECTS PARAMETERS
*
+KT1      = -0.2535690          LKT1     = -2.4956870E-09      WKT1     = -1.5279610E-07      
+PKT1     = 4.9609050E-14       KT2      = -1.7916219E-02      LKT2     = -1.6789700E-09      
+WKT2     = -4.0857120E-10      PKT2     = -2.5355550E-15      AT       = 2.0000000E+04       
+UTE      = -1.0260620          LUTE     = -8.1478210E-09      WUTE     = 2.0666280E-07       
+PUTE     = -1.7712639E-13      UA1      = 2.0399999E-09       UB1      = -1.5461820E-18      
+LUB1     = 1.6306660E-25       WUB1     = -5.6945430E-25      PUB1     = -1.1277000E-31      
+UC1      = 1.0037150E-10       LUC1     = 1.4397060E-17       WUC1     = -9.6272360E-17      
+PUC1     = -1.0310020E-23      KT1L     = 0.00                PRT      = 0.00                
*
* CAPACITANCE PARAMETERS
*
+CJ       = 8.964788E-07        MJ       = 0.3259624           PB       = 0.7076023           
+CJSW     = 2.50664E-13         MJSW     = 0.1513672           PBSW     = 0.7076023           
+CJSWG    = 3.00664E-13         MJSWG    = 0.3513672           PBSWG    = 0.7076023           
+TPB      = 1.687207E-03        TPBSW    = 1.687207E-03        TCJ      = 9.923959E-04        
+TCJSW    = 5.019466E-04        JS       = 7.93E-06            JSW      = 7.00E-11            
+NJ       = 1.0                 XTI      = 3.0                 CGDO     = '3.185E-10*nmos_cgdfac'            
+CGSO     = '3.95E-10*nmos_cgdfac'            CGBO     = 1.0E-13             CAPMOD   = 3                   
+NQSMOD   = 0                   ELM      = 0                   XPART    = 0                   
+CF      = 0             	TLEV     = 1       	       TLEVC    = 1              
+CALCACM = 1
*********added AC parameters*****
+DLC=8.7533e-8   Llc= -1.9017E-14    
+VOFFCV= 0.1066 LVOFFCV= -5.06e-8
+CGDL='4.7973e-10*nmos_cgdfac'  LCGDL= -7.622E-17
+CGSL='7.33e-10*nmos_cgdfac'  LCGSL= -1.20779E-16
+CLE=1 CLC=3e-10
+NOFF=1.2
*SFVTFLAG = 0              VFBFLAG  = 1   )           

**********************************
***************************************************************
*            3.3V  PMOS DEVICES                               *
***************************************************************
 
.MODEL pch_rf33   PMOS (  
+LMIN     = 3E-07          
+Noimod = 1          AF    = 1.542     EF  = 1.094      KF   = 1.54E-26
+LMAX    = 5E-07          WMIN     = 2.5E-06       WMAX   = 2.5E-06      
+LEVEL   = 49             TNOM     = 25             VERSION  = 3.2            
+TOX      = '6.77E-09*pmos_toxfac'
+TOXM     = '6.77E-09*pmos_toxfac'            XJ       = 1.7000001E-07       
+NCH      = 4.9500000E+17       LLN      = 1.0000000           LWN      = 1.0000000           
+WLN      = 1.0000000           WWN      = 1.0000000           LINT     = 3.5000000E-08       
+LL       = 0.00                LW       = 0.00                LWL      = 0.00                
+WINT     = 3.5000000E-08       WL       = 0.00                WW       = 0.00                
+WWL      = 0.00                MOBMOD   = 1                   BINUNIT  = 2                   
+XL       = '-2E-08*pmos_dlfac' XW       = '1e-6*pmos_dwfac'   LMLT     = 1                   
+WMLT     = 1                   BINFLAG  = 0                   DWG      = 0.00                
+DWB      = 0.00                
* DIODE PARAMETERS
+ACM      = 12                  LDIF     = 9.00E-08            HDIF     = 2.00E-07            
+RSH      = 7.2                 RD       = 0                   RS       = 0                   
+RSC      = 0                   RDC      = 0                                      
*
* THRESHOLD VOLTAGE PARAMETERS
*
+VTH0     = '-0.7794082*pmos_vthfac'
+LVTH0    = 2.9174400E-08       WVTH0    = 1.3822050E-07       
+PVTH0    = -4.7803770E-14      K1       = '0.7703792*pmos_k1fac'
+LK1      = 4.7912380E-08       
+WK1      = -6.1627210E-09      PK1      = -5.7079160E-15      K2       = 0.1315091           
+LK2      = -2.9677160E-08      WK2      = -2.6652980E-08      PK2      = 1.1863930E-14       
+K3       = 0.00                DVT0     = 0.00                DVT1     = 0.00                
+DVT2     = 0.00                DVT0W    = 0.00                DVT1W    = 0.00                
+DVT2W    = 0.00                NLX      = 0.00                W0       = 0.00                
+K3B      = 0.00                NGATE    = 0.00                VFB      = 99.0000000          
*
* MOBILITY PARAMETERS
*
+VSAT     = 1.1958270E+05       LVSAT    = -3.9288950E-03      WVSAT    = 9.1457880E-03       
+PVSAT    = -3.7497720E-09      UA       = 1.1416620E-09       LUA      = -1.5603519E-16      
+WUA      = 7.9376820E-16       PUA      = -1.9869220E-22      UB       = 2.5250249E-19       
+LUB      = 2.2445541E-25       WUB      = -1.4172720E-24      PUB      = 3.4023830E-31       
+UC       = -7.1369630E-11      LUC      = 2.2632790E-17       WUC      = -1.8019050E-16      
+PUC      = 3.9216490E-23       RDSW     = '900*pmos_rdswfac'  PRWB     = 0.00                
+PRWG     = 0.00                WR       = 1.0000000           U0       = '0.01008642*pmos_uefffac'       
+LU0      = -7.0236690E-11      WU0      = -5.9939580E-10      PU0      = 8.6167180E-17       
+A0       = 1.1407400           LA0      = -8.2362710E-08      WA0      = 1.4912089E-07       
+PA0      = -4.5613300E-14      KETA     = -1.1352910E-02      LKETA    = 1.9204109E-09       
+WKETA    = 1.4552420E-08       PKETA    = -7.3035160E-15      A1       = 0.00                
+A2       = 0.9900000           AGS      = 2.0000000E-02       B0       = 0.00                
+B1       = 0.00                
*
* SUBTHRESHOLD CURRENT PARAMETERS
*
+VOFF     = -0.1249071          LVOFF    = 8.9414560E-09       WVOFF    = -2.0841340E-09      
+PVOFF    = -2.6938661E-15      NFACTOR  = 1.0000000           CIT      = 5.6242540E-04       
+LCIT     = -2.1703370E-11      WCIT     = -1.6475810E-10      PCIT     = 5.3283360E-17       
+CDSC     = 0.00                CDSCB    = 0.00                CDSCD    = 0.00                
+ETA0     = -2.8330681E-04      LETA0    = 1.5715580E-10       WETA0    = -3.6583150E-10      
+PETA0    = 1.4999090E-16       ETAB     = 8.7878470E-04       LETAB    = -4.0130170E-10      
+WETAB    = -3.3683250E-10      PETAB    = 1.3810130E-16       DSUB     = 0.00                
*
* ROUT PARAMETERS
*
+PCLM     = 0.6642304           LPCLM    = 6.4582120E-09       WPCLM    = 4.2737330E-08       
+PPCLM    = 1.7767399E-15       PDIBLC1  = 1.0000000E-06       PDIBLC2  = -3.7638230E-03      
+LPDIBLC2 = 1.9531670E-09       WPDIBLC2 = 5.6213120E-09       PPDIBLC2 = -2.3047379E-15      
+PDIBLCB  = 1.0000000E-02       DROUT    = 0.00                PSCBE1   = 3.3083470E+08       
+LPSCBE1  = 7.8577890           WPSCBE1  = -18.2915800         PPSCBE1  = 7.4995460E-06       
+PSCBE2   = 5.0000000E-07       PVAG     = 0.00                DELTA    = 1.0000000E-02       
+ALPHA0   = 0                   ALPHA1   = 0.139               BETA0    = 16.1083200          
*
* TEMPERATURE EFFECTS PARAMETERS
*
+KT1      = -0.3348261          LKT1     = 1.3294890E-08       WKT1     = 2.9812519E-10       
+PKT1     = 3.1137369E-15       KT2      = -3.0654950E-02      LKT2     = 8.7280060E-10       
+WKT2     = -4.5288680E-11      PKT2     = 3.1860170E-16       AT       = -5.0000000E+04      
+UTE      = -0.1308300          LUTE     = -2.0317449E-07      WUTE     = -3.8055390E-07      
+PUTE     = 2.2297420E-13       UA1      = 3.6298140E-09       LUA1     = -6.5551380E-16      
+WUA1     = -1.8866009E-15      PUA1     = 7.7350630E-22       UB1      = -2.5636720E-18      
+LUB1     = 2.0155830E-25       WUB1     = 6.3441180E-25       PUB1     = -2.4314391E-31      
+UC1      = 4.8522400E-11       LUC1     = -1.0582910E-17      WUC1     = 4.9992710E-17       
+PUC1     = -1.1136940E-24      KT1L     = 0.00                PRT      = 0.00                
*
* CAPACITANCE PARAMETERS
*
+CJ       = 1.03531E-06         MJ       = 0.3954951           PB       = 0.8049122           
+CJSW     = 2.23115E-13         MJSW     = 0.2573111           PBSW     = 0.8049122           
+CJSWG    = 2.345762E-13        MJSWG    = 0.2573111           PBSWG    = 0.8049122           
+TPB      = 1.625007E-03        TPBSW    = 1.625007E-03        TCJ      = 9.940197E-04        
+TCJSW    = 6.908749E-04        JS       = 3.10E-06            JSW      = 2.80E-11            
+NJ       = 1.0                 XTI      = 3.0                 CGDO     = '3.32E-10*pmos_cgdfac'            
+CGSO     = '2.75E-10*pmos_cgdfac'            CGBO     = 1.0E-13             CAPMOD   = 3                   
+NQSMOD   = 0                   ELM      = 0                   XPART    = 0             
+CF       = 0              
+TLEV    = 1              TLEVC    = 1              CALCACM  = 1              
*********added AC parameters*****
+NOFF=3.5 
+CLE=1.5 CLC=1.5e-8
+CKAPPA=0.55
*+SFVTFLAG= 0              VFBFLAG  = 1 
+DLC     = 4.6833E-8  Llc= -1e-15
+VOFFCV= 0.0811 LVOFFCV= -0.0202E-6
+CGDL='3.2281E-10*pmos_cgdfac' LCGDL= -0.2115E-16  
+CGSL='2.7138E-10*pmos_cgdfac' LCGSL= -0.0725E-16 )

*
.ENDL MOS_RF33  
*
.LIB DIO_RF33
*
***************************************************************
*                      MODEL OF 3.3V N+/PW DIODE              *
***************************************************************                 
******** diode field edge **************
.MODEL ndio_rf33_f D (
+LEVEL = 1
+TLEVC=1
+ CJ='0.00177964788*ndio_cjfac'
+ MJ=0.3259624
+ PB=0.7076023
+ CJSW='5.50664E-10*ndio_cjfac'
+ MJSW=0.1513672
+ PHP=0.7076023
+CTA=0.0009923959
+CTP=0.0005019466 
+TPB=0.001687207
+TPHP=0.001687207 )
********** diode gate edge ***************
.MODEL ndio_rf33_g D (
+LEVEL = 1
+TLEVC=1
+ CJ='0.0008964788*ndio_cjfac'
+ MJ=0.3259624
+ PB=0.7076023
+ CJSW='5.7664E-10*ndio_cjfac'
+ MJSW=0.3513672
+ PHP=0.7076023
+CTA=0.0009923959
+CTP=0.0005019466 
+TPB=0.001687207
+TPHP=0.001687207 )
**********************************          
                                                
***************************************************************
*                      MODEL OF 3.3V P+/NW DIODE              *
***************************************************************
 **** field edge diode  *******
.MODEL pdio_rf33_f D (
+LEVEL = 1
+TLEVC=1
+ CJ='0.00143531*pdio_cjfac'
+ MJ=0.3954951
+ PB=0.8049122
+ CJSW='3.23115E-10*pdio_cjfac'
+ MJSW=0.2573111
+ PHP=0.8049122
+CTA=0.0009940197
+CTP=0.0006908749
+TPB=0.001625007
+TPHP=0.001625007 )
****** gate edge diode *********
.MODEL pdio_rf33_g D (
+LEVEL = 1
+TLEVC=1
+ CJ='0.00143531*pdio_cjfac'
+ MJ=0.3954951
+ PB=0.8049122
+ CJSW='3.483115E-10*pdio_cjfac'
+ MJSW=0.2573111
+ PHP=0.8049122
+CTA=0.0009940197
+CTP=0.0006908749
+TPB=0.001625007
+TPHP=0.001625007 )
**********************************      
*                                                   
.ENDL DIO_RF33
*
*
.LIB DIO_XJVAR
***************************************************************
*         MODEL OF P+/NW RF JUNCTION VARACTOR DIODE           *
***************************************************************
*
.MODEL pdio_xj D  (
+ LEVEL  = 3               
+ IS     = 4.92E-6         RS     = 1E-9           N      = 1.25            
+ BV     = 10.2            IBV    = 1E-3           IK     = 1E20            
+ IKR    = 1E10            JSW    = 1.02E-11       AREA   = 1.68E-11 
+ PJ     = 8.084E-5        CJ  = '1.22E-3*cj_fac'  PB     = 0.7         
+ MJ     = 0.12            CJSW= '2.13E-10*cj_fac' PHP    = 0.7         
+ MJSW   = 0.1             TLEV   = 1              EG     = 1.17            
+ XTI    = 3               TCV    = -8.8E-4        TRS    = 1.2E-4          
+ TLEVC  = 1               CTA    = 9.739001E-4    CTP    = 4.130718E-4       
+ TPB    = 1.572025E-3     TPHP   = 1.572025E-3    TREF   = 25              
+ FC     = 0               FCS    = 0             )  

.MODEL nwdio_xj D  (
+ LEVEL  = 3               
+ IS     = 1.55E-5         RS     = 2E-9           N      = 1.38            
+ BV     = 14.75           IBV    = 1E-3           IK     = 1E20            
+ IKR    = 1E10            JSW    = 4.75E-11       
+ CJ     = '2E-5*csub_fac'            PB     = 0.8846489         
+ MJ     = 0.1             CJSW   = '1E-10*csub_fac' 
+ PHP    = 0.8846489         
+ MJSW   = 0.1             TLEV   = 1              EG     = 1.17            
+ XTI    = 3               TCV    = -9.6E-4        TRS    = 1.125E-3        
+ TLEVC  = 1               CTA    = 2.8425E-3      CTP    = 1.5284E-3       
+ TPB    = 2.819E-3        TPHP   = 2.819E-3       TREF   = 25              
+ FC     = 0               FCS    = 0              )
*                                                    
.ENDL DIO_XJVAR

.LIB DIO_ESD
***************************************************************
*         MODEL OF P+/NW RF LCESD DIODE                       *
***************************************************************
.MODEL PDIO_ESD D                                     
+ LEVEL  = 3               
+ IS     = 4.92E-6         RS     = 2.5033E-15      N      = 1.25            
+ BV     = 10.2            IBV    = 1E-3            IK     = 1E20            
+ IKR    = 1E10            JSW    = 1.02E-11        AREA   = 7.5E-8          
+ PJ     = 1.1E-3          CJ     = 1.121E-3        PB     = 0.895226         
+ MJ     = 0.4476          CJSW   = 2.481E-10       PHP    = 0.895226         
+ MJSW   = 0.3683619       TLEV   = 1               EG     = 1.17            
+ XTI    = 3               TCV    = -8.8E-4         TRS    = 1.2E-4          
+ TLEVC  = 1               CTA    = 9.739001E-4     CTP    = 4.130718E-4       
+ TPB    = 1.572025E-3     TPHP   = 1.572025E-3     TREF   = 25              
+ FC     = 0               FCS    = 0               
*
***************************************************************
*         MODEL OF NW/Psub RF LCESD DIODE                     *
***************************************************************
.MODEL NWDIO_ESD D                                    
+ LEVEL  = 3               
+ IS     = 1.55E-5         RS     = 1.951E-15       N      = 1.38            
+ BV     = 14.75           IBV    = 1E-3            IK     = 1E20            
+ IKR    = 1E10            JSW    = 4.75E-11        AREA   = 7.5E-8          
+ PJ     = 1.1E-3          CJ     = 1.337566E-4     PB     = 0.5846489         
+ MJ     = 0.3883243       CJSW   = 5.333577E-10    PHP    = 0.5846489         
+ MJSW   = 0.2345684       TLEV   = 1               EG     = 1.17            
+ XTI    = 3               TCV    = -9.6E-4         TRS    = 1.125E-3        
+ TLEVC  = 1               CTA    = 2.8425E-3       CTP    = 1.5284E-3       
+ TPB    = 2.819E-3        TPHP   = 2.819E-3        TREF   = 25              
+ FC     = 0               FCS    = 0               
.ENDL DIO_ESD


